{*******************************************************************}
{                                                                   }
{  MainFrm.pas, Copyright (c) Simon Page 1998                       }
{                                                                   }
{  Version....: 1.13                                                }
{                                                                   }
{  Purpose....: Demonstration form for TWheelMouse component        }
{                                                                   }
{  Requires...: Delphi 2 or greater                                 }
{                                                                   }
{*******************************************************************}

unit MainFrm;

{$J+} { Assignable typed constants }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WheelMs, ExtCtrls, StdCtrls, ComCtrls, Grids;

type
  TForm1 = class(TForm)
    WheelMouse1: TWheelMouse;
    StatusBar1: TStatusBar;
    TopPanel: TPanel;
    BottomPanel: TPanel;
    ListBox1: TListBox;
    ComboBox1: TComboBox;
    Edit1: TEdit;
    UpDown1: TUpDown;
    TrackBar1: TTrackBar;
    Label3: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    NativeLab: TLabel;
    AltLab: TLabel;
    ScrollLinesLab: TLabel;
    ScrollBar1: TScrollBar;
    Memo1: TMemo;
    LeftBotPan: TPanel;
    StringGrid1: TStringGrid;
    RightBotPanel: TPanel;
    ListView1: TListView;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure WheelMouse1Scroll(Sender: TObject; Shift: TShiftState; X, Y,
      NumLines, PageOffSet: Integer);
    procedure WheelMouse1RawScroll(zDelta, X, Y, ScrollLines: Integer);
    procedure StringGrid1MouseWheelDown(Sender: TObject;
      Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
    procedure StringGrid1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{$IFNDEF VER80}
  {$IFNDEF VER90}
    {$IFNDEF VER100}
      {$DEFINE VERSION4_UP}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}

procedure TForm1.FormCreate(Sender: TObject);
const
  NoYesString: array[False..True] of String = ('No', 'Yes');
var
  I, J: Integer;
  NewItem: TListItem;
begin
  with WheelMouse1 do
  begin
    NativeLab.Caption := NoYesString[NativeSupport];
    AltLab.Caption := NoYesString[AltSupport];
    ScrollLinesLab.Caption := IntToStr(ScrollLines);
  end;

{$IFDEF VERSION4_UP}
    { Manually connect up event handlers as they aren't present on D2, D3 }
   StringGrid1.OnMouseWheelDown := StringGrid1MouseWheelDown;
   StringGrid1.OnMouseWheelUp := StringGrid1MouseWheelUp;
{$ENDIF}

  for I := 1 to 30 do ListBox1.Items.Add('TListBox item ' + IntToStr(I));

  for I := 1 to 30 do ComboBox1.Items.Add('TComboBox item ' + IntToStr(I));
  ComboBox1.ItemIndex := 0;

  with StringGrid1 do
    for I := 1 to RowCount - FixedRows  do
      for J := 1 to ColCount - FixedCols do
         StringGrid1.Cells[J, I] := '(' + IntToStr(I) + ', ' + IntToStr(J) + ')';

  for I := 1 to 15 do
  begin
    NewItem := ListView1.Items.Add;
    NewItem.Caption := 'List view item number ' + IntToStr(I);
    for J := 1 to 4 do
      NewItem.SubItems.Add('Sub item ' + IntToStr(J));
  end;
end;

procedure TForm1.WheelMouse1Scroll(Sender: TObject; Shift: TShiftState; X,
  Y, NumLines, PageOffSet: Integer);
begin
  StatusBar1.Panels[0].Text := ' OnScroll event (' + IntToStr(X) + ', ' +
    IntToStr(Y) + ')  NumLines: ' + IntToStr(NumLines) + '  PageOffset:' +
    IntToStr(PageOffset);
end;

procedure TForm1.WheelMouse1RawScroll(zDelta, X, Y, ScrollLines: Integer);
begin
  StatusBar1.Panels[1].Text := ' OnRawScroll event (' +  IntToStr(X) + ', ' +
    IntToStr(Y) + ')  ZDelta:' + IntToStr(zDelta) + '  ScrollLines:' +
    IntToStr(ScrollLines);
end;

procedure TForm1.StringGrid1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  { only required for D4 if you want to change grids standard behaviour }
  Handled := WheelMouse1.HandleVCLWheelDown(MousePos);
end;

procedure TForm1.StringGrid1MouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
  { only required for D4 if you want to change grids standard behaviour }
  Handled := WheelMouse1.HandleVCLWheelUp(MousePos);
end;

end.
